'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.read = read;
exports.write = write;
exports.parse = parse;

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function read(name) {
  return new Promise(function (resolve, reject) {
    if (Buffer.isBuffer(name)) {
      return resolve({ name: 'stdin', content: name });
    }

    _fs2.default.readFile(name, function (err, content) {
      if (err) {
        err.file = name;
        return reject(err);
      }

      resolve({ name: name, content: content });
    });
  });
}

function write(name, content) {
  return new Promise(function (resolve, reject) {
    _fs2.default.writeFile(name, content, function (err, data) {
      if (err) {
        err.file = name;
        return reject(err);
      }

      resolve({ name: name, content: content });
    });
  });
}

function parse(file) {
  return new Promise(function (resolve, reject) {
    try {
      file.content = JSON.parse(file.content);
      resolve(file);
    } catch (err) {
      err.file = file.name;
      reject(err);
    }
  });
}